/** IntList class
//    This class assembles lists of integers - primarily for
//    testing
**/

package ciips.animation;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;

public class IntList {
	protected int nodes_array[];
	protected DataInputStream inStream;
	protected int num = 0;

	private static final boolean DEBUG = false;

	public IntList() { // Construct an empty list
		}
	
	public IntList( URL url ) {
		try {
			URLConnection urlc = url.openConnection();
			inStream = new DataInputStream( urlc.getInputStream() );
			num = loadNodes(inStream);
			}
		catch( IOException e ) {
			System.out.println("IntList: URL connection error");
			}
		}

	/** Construct an integer list from a string containing a space separated
			list of integers
	**/
	public IntList( String line ) throws Exception {
		String item1;
		Vector x = new Vector( 10 );
		if( DEBUG )	System.out.println("IntList: line [" + line + "]" );
		StringTokenizer Data = new StringTokenizer(line, " ");
		while( Data.hasMoreTokens() ) {
			item1 = Data.nextToken();
			if ( item1 == null ) break;
			if( DEBUG )	System.out.println("IntList - item [" + item1 + "]");		 
			// x.add( item1 );
			x.addElement( item1 );
			}
		num = x.size();
		if( DEBUG )	System.out.println("IntList - found " + num + " items" );		 
		if ( num > 0 ) {
			nodes_array = new int[ num ];
			for(int k=0;k<num;k++ ) {
				item1 = (String)(x.elementAt(k));
				if( DEBUG )	System.out.println("IntList - item [" + item1 + "]");		 
				nodes_array[k] = Integer.parseInt( item1 );
				}
			}
		else {
			throw new Exception( "IntList: no integers in string" );
			}
		}
	
	private int loadNodes(DataInputStream inStream) {
		int n_nodes = 0, cnt = 0;
		String line = " ", item1;
		
		if( DEBUG ) System.out.println("Load_Nodes: entry" );
		try {
			if ((line = inStream.readLine()) != null) {
				if( DEBUG ) System.out.println("Load_Nodes: line [" + line + "]" );
				StringTokenizer Data = new StringTokenizer(line, " ");
				item1 = Data.nextToken();
				n_nodes = Integer.parseInt( item1 );
				if( DEBUG ) System.out.println("instream is "+ n_nodes);		 
				nodes_array = new int[n_nodes];
		
				while(( cnt < n_nodes ) && ((line = inStream.readLine()) != null) ) {
					if( DEBUG ) System.out.println("Load_Nodes: line [" + line + "]" );
					Data = new StringTokenizer(line, " ");
					item1 = Data.nextToken();
					nodes_array[cnt] = Integer.parseInt(item1);
					cnt++;	
					}				
				}
			}	
		catch (IOException e) {
			System.err.println("IntList: error in file" + e.toString());
			System.exit(1);
			}
		catch ( NumberFormatException e ) {
			System.err.println("IntList:loadnodes - Number format [" + line + "]");
			}
		return n_nodes;	
		}
	public int elementAt( int k ) {
		if ( k < nodes_array.length ) {
			return nodes_array[k];
			}
		else return -99;
		}

	public int size() {
		return num;
		}

	public String toString() {
		String s = "IntList(" + nodes_array.length + ") ";
		for( int k=0;k<nodes_array.length;k++ ) {
			s = s + nodes_array[k] + ";";
			}
		return s;
		}
	}
